# :key: Vue Auth Plugin

A simple authentication and authorization library for Vue.js using typescript

Inspired in [@websanova/vue-auth](https://github.com/websanova/vue-auth)

Pull requests and issues are welcome

# :eyes: Project status

[![@d0whc3r/vue-auth-plugin Dev Token](https://badge.devtoken.rocks/@d0whc3r/vue-auth-plugin)](https://devtoken.rocks/package/@d0whc3r/vue-auth-plugin)
[![Netlify Status](https://api.netlify.com/api/v1/badges/f40b0f7c-b2a8-4cd5-ba62-fe2da3dfa48c/deploy-status)](https://app.netlify.com/sites/vue-auth-plugin/deploys)
[![pipeline status](https://gitlab.com/d0whc3r/vue-auth-plugin/badges/master/pipeline.svg)](https://github.com/d0whc3r/vue-auth-plugin)
[![codecov](https://codecov.io/gh/d0whc3r/vue-auth-plugin/branch/master/graph/badge.svg)](https://codecov.io/gh/d0whc3r/vue-auth-plugin)
[![Codacy Badge](https://api.codacy.com/project/badge/Grade/9883d853d9f5446b9722277327acc580)](https://www.codacy.com/app/d0whc3r/vue-auth-plugin?utm_source=github.com&amp;utm_medium=referral&amp;utm_content=d0whc3r/vue-auth-plugin&amp;utm_campaign=Badge_Grade)
[![Quality Gate Status](https://sonarcloud.io/api/project_badges/measure?project=d0whc3r_vue-auth-plugin&metric=alert_status)](https://sonarcloud.io/dashboard?id=d0whc3r_vue-auth-plugin)
[![Maintainability Rating](https://sonarcloud.io/api/project_badges/measure?project=d0whc3r_vue-auth-plugin&metric=sqale_rating)](https://sonarcloud.io/dashboard?id=d0whc3r_vue-auth-plugin)
[![Security Rating](https://sonarcloud.io/api/project_badges/measure?project=d0whc3r_vue-auth-plugin&metric=security_rating)](https://sonarcloud.io/dashboard?id=d0whc3r_vue-auth-plugin)
[![Bugs](https://sonarcloud.io/api/project_badges/measure?project=d0whc3r_vue-auth-plugin&metric=bugs)](https://sonarcloud.io/dashboard?id=d0whc3r_vue-auth-plugin)
[![Vulnerabilities](https://sonarcloud.io/api/project_badges/measure?project=d0whc3r_vue-auth-plugin&metric=vulnerabilities)](https://sonarcloud.io/dashboard?id=d0whc3r_vue-auth-plugin)
![dependencies](https://img.shields.io/david/d0whc3r/vue-auth-plugin.svg)
[![npm version](https://img.shields.io/npm/v/@d0whc3r%2Fvue-auth-plugin.svg)](https://www.npmjs.com/package/@d0whc3r/vue-auth-plugin)


# :rocket: Install

```bash
yarn add @d0whc3r/vue-auth-plugin
```

# :notebook: Documentation and Usage

[https://vue-auth-plugin.netlify.com](https://vue-auth-plugin.netlify.com)

[https://d0whc3r.github.io/vue-auth-plugin](https://d0whc3r.github.io/vue-auth-plugin)

## :wrench: Project demo

```bash
git clone https://github.com/d0whc3r/vue-auth-plugin.git
cd vue-auth-plugin
yarn install
yarn demo
```

## :bar_chart: Project tests

```bash
yarn test
```

> Plugin created using [vue-cli 3](https://cli.vuejs.org/) and [p11n plugin](https://github.com/kazupon/vue-cli-plugin-p11n)

# :copyright: License

[MIT](http://opensource.org/licenses/MIT)

# :bookmark: Keywords

`vue`, `plugin`, `auth`, `authorization`, `authentication`, `login`, `roles`, `vuejs`, `vue2`, `typescript`
